package at.ac.uibk.gitsearch.service.mapper;


import at.ac.uibk.gitsearch.domain.*;
import at.ac.uibk.gitsearch.service.dto.SavedSearchesDTO;

import org.mapstruct.*;

/**
 * Mapper for the entity {@link SavedSearches} and its DTO {@link SavedSearchesDTO}.
 */
@Mapper(componentModel = "spring", uses = {UserMapper.class})
public interface SavedSearchesMapper extends EntityMapper<SavedSearchesDTO, SavedSearches> {

    @Mapping(source = "userId.id", target = "userIdId")
    @Mapping(source = "userId.login", target = "userIdLogin")
    SavedSearchesDTO toDto(SavedSearches savedSearches);

    @Mapping(source = "userIdId", target = "userId")
    SavedSearches toEntity(SavedSearchesDTO savedSearchesDTO);

    default SavedSearches fromId(Long id) {
        if (id == null) {
            return null;
        }
        SavedSearches savedSearches = new SavedSearches();
        savedSearches.setId(id);
        return savedSearches;
    }
}
